#!/usr/bin/ruby
# encoding: utf-8

require 'gtk2'
require 'vte'
require "rexml/document"
require 'optparse'
require "RescueScreen" 

# require "BackupScreen"
# require "CloneScreen" 
# require "VirusScreen"
# require "ShredderScreen"
# require "SambaScreen"
# require "LicenseScreen"
require "TileHelpers"
require "MfsTranslator"
require "MfsDiskDrive"
require "MfsSinglePartition"
# require "FileUtils"

# Constants for positions:

OK_X = 864
OK_Y = 536
CANCEL_X = 728
CANCEL_Y = 536
SETTINGS_X = 592
SETTINGS_Y = 536

$lastpulse = Time.now.to_f 

def create_hdd_layer(layers, fixed)
	hddfixed = Gtk::Fixed.new
	bgimg = Gtk::Image.new("background.png")
	layers["hddforensics"] = hddfixed 
	fixed.put(hddfixed,0,0)
	hddfixed.put(bgimg, 0, 0)
	 
	undel_button = Gtk::Button.new()
	undel_hbox = Gtk::HBox.new
	undel_hbox.pack_start_defaults Gtk::Image.new("icons/datenrettung_green.png")
	undel_label = Gtk::Label.new # (rescuescreen.start_label) 
	undel_label.set_markup "Run photorec - put some text here" # (rescuescreen.start_label)
	undel_label.wrap = true 
	undel_label.width_request = 243
	undel_label.height_request = 194
	undel_hbox.pack_start_defaults undel_label 
	undel_button.add(undel_hbox) 
	hddfixed.put(undel_button, 200, 94)
	
	undel_button.signal_connect("clicked") { 
		layers.each { |k,v| v.hide_all }
		#	rescuescreen.reread_drivelist 
		layers["rescue_start"].show_all 
	}
	
	vss_button = Gtk::Button.new()
	vss_hbox = Gtk::HBox.new
	vss_hbox.pack_start_defaults Gtk::Image.new("icons/datenrettung_green.png")
	vss_label = Gtk::Label.new # (rescuescreen.start_label) 
	vss_label.set_markup "Compare files upon VSS - put some text here" # (rescuescreen.start_label)
	vss_label.wrap = true 
	vss_label.width_request = 243
	vss_label.height_request = 194
	vss_hbox.pack_start_defaults vss_label 
	vss_button.add(vss_hbox) 
	hddfixed.put(vss_button, 596, 94)
	
	cancel = Gtk::Button.new(Gtk::Stock::CANCEL) 
	cancel.width_request = 128
	cancel.height_request = 32 
	cancel.signal_connect("clicked") { 
		layers.each { |k,v| v.hide_all }
		layers["start"].show_all 
	}
	hddfixed.put(cancel, OK_X, OK_Y)
	
end



lang = ENV['LANGUAGE'][0..1]
lang = ENV['LANG'][0..1] if lang.nil?
lang = "en" if lang.nil?
# @tl = MfsTranslator.new(lang, "rescuegui.xml") 

# Identify the correct manual
manualpath = "/lesslinux/cdrom/Manual"
manualpath = "/lesslinux/isoloop/Manual" if File.directory?("/lesslinux/isoloop/Manual")
manualpath = "/lesslinux/cdrom/Manual" if File.directory?("/lesslinux/cdrom/Manual")
@manual = manualpath + "/SECUPERTS_Forensic_Kit_en-EN.pdf" 
@manual = manualpath + "/SECUPERTS_Forensic_Kit_de-DE.pdf" if lang == "de"

top_buttons = Array.new

window = Gtk::Window.new
window.set_size_request(1000, 576)
window.border_width = 0
window.window_position = Gtk::Window::POS_CENTER_ALWAYS

window.deletable = false
window.decorated = false
window.allow_grow = false
window.allow_shrink = false
window.title = "ForensicGUI"

fixed = Gtk::Fixed.new

# Layers are stored in a Hash:

layers = Hash.new

# First layer for starting page

bgimg = Gtk::Image.new("background.png")
startfixed = Gtk::Fixed.new
layers["start"] = startfixed 
startfixed.put(bgimg, 0, 0)

# Layers provided by component "HddForensics"

# rescuescreen = RescueScreen.new(layers, fixed) 
hddfor_button = Gtk::Button.new()
hddfor_hbox = Gtk::HBox.new
hddfor_hbox.pack_start_defaults Gtk::Image.new("icons/datenrettung_green.png")
hddfor_label = Gtk::Label.new # (rescuescreen.start_label) 
hddfor_label.set_markup "HDD forensics, VSS, empty space - put some text here" # (rescuescreen.start_label)
hddfor_label.wrap = true 
hddfor_label.width_request = 243
hddfor_label.height_request = 214
hddfor_hbox.pack_start_defaults hddfor_label 
hddfor_button.add(hddfor_hbox) 

# rescue_button.image = Gtk::Image.new("icons/datenrettung_green.png")
hddfor_button.signal_connect("clicked") { 
	layers.each { |k,v| v.hide_all }
#	rescuescreen.reread_drivelist 
	layers["hddforensics"].show_all 
}
startfixed.put(hddfor_button, 200, 94)

# Layers provided by component "BrowserEmailChat"

# rescuescreen = RescueScreen.new(layers, fixed) 
browser_button = Gtk::Button.new()
browser_hbox = Gtk::HBox.new
browser_hbox.pack_start_defaults Gtk::Image.new("icons/datenrettung_green.png")
browser_label = Gtk::Label.new # (rescuescreen.start_label) 
browser_label.set_markup "Browser, Email, Chat - put some text here" # (rescuescreen.start_label)
browser_label.wrap = true 
browser_label.width_request = 243
browser_label.height_request = 214
browser_hbox.pack_start_defaults browser_label 
browser_button.add(browser_hbox) 

# rescue_button.image = Gtk::Image.new("icons/datenrettung_green.png")
#rescue_button.signal_connect("clicked") { 
#	layers.each { |k,v| v.hide_all }
#	rescuescreen.reread_drivelist 
#	layers["rescue_start"].show_all 
#}
startfixed.put(browser_button, 596, 94)

# Layers provided by component "NetworksForensic"

# rescuescreen = RescueScreen.new(layers, fixed) 
nwfor_button = Gtk::Button.new()
nwfor_hbox = Gtk::HBox.new
nwfor_hbox.pack_start_defaults Gtk::Image.new("icons/network_green.png")
nwfor_label = Gtk::Label.new # (rescuescreen.start_label) 
nwfor_label.set_markup "Network forensics - put some text here" # (rescuescreen.start_label)
nwfor_label.wrap = true 
nwfor_label.width_request = 243
nwfor_label.height_request = 214
nwfor_hbox.pack_start_defaults nwfor_label 
nwfor_button.add(nwfor_hbox) 

# rescue_button.image = Gtk::Image.new("icons/datenrettung_green.png")
#rescue_button.signal_connect("clicked") { 
#	layers.each { |k,v| v.hide_all }
#	rescuescreen.reread_drivelist 
#	layers["rescue_start"].show_all 
#}
startfixed.put(nwfor_button, 200, 334)

# Layers provided by component "CloneImageDelete"

# rescuescreen = RescueScreen.new(layers, fixed) 
image_button = Gtk::Button.new()
image_hbox = Gtk::HBox.new
image_hbox.pack_start_defaults Gtk::Image.new("icons/laufwerkklonen_green.png")
image_label = Gtk::Label.new # (rescuescreen.start_label) 
image_label.set_markup "Imaging, Cloning, Deleting - put some text here" # (rescuescreen.start_label)
image_label.wrap = true 
image_label.width_request = 243
image_label.height_request = 214
image_hbox.pack_start_defaults image_label 
image_button.add(image_hbox) 

# rescue_button.image = Gtk::Image.new("icons/datenrettung_green.png")
#rescue_button.signal_connect("clicked") { 
#	layers.each { |k,v| v.hide_all }
#	rescuescreen.reread_drivelist 
#	layers["rescue_start"].show_all 
#}
startfixed.put(image_button, 596, 334)




# Icons shown in any mode - must be added latest!

button_count = 0
[ 
	"icons/help.png",
	"icons/browser.png", 
	"icons/network.png",
	"icons/usb.png", 
	"icons/shutdown.png"
].each { |i| 
	ico = Gtk::Button.new # Gtk::EventBox.new
	ico.image = Gtk::Image.new(i)
	fixed.put(ico, 752 + button_count*48, 8)
	top_buttons.push(ico)
	button_count += 1
}
top_commands = [ 
	"evince #{@manual} &", 
	"su surfer -c firefox &",
	"wicd-gtk --no-tray &",
	"usbinstall.sh &",
	"shutdown-wrapper.sh"
]
0.upto(top_buttons.size - 1) { |n|
	top_buttons[n].signal_connect('button-release-event') { |x, y|
		if y.button == 1 
			tc = top_commands[n]
			system(tc)
		elsif y.button == 3
			layers.each { |k,v| v.hide_all }
			top_buttons.each { |v| v.hide_all }
			layers["license"].show_all 
		end
	}
}
# licensescreen = LicenseScreen.new(layers, fixed, top_buttons) 

rescuescreen = RescueScreen.new(layers, fixed) 
create_hdd_layer(layers, fixed)
fixed.put(startfixed,0,0)


window.add fixed
window.signal_connect('destroy') { Gtk.main_quit }
window.show_all 
# unshow all layers
# layers.each { |k,v| v.hide_all }
# top_buttons.each { |v| v.hide_all }
#if File.exist?("/var/run/lesslinux/license_accepted") 
	# layers["start"].show_all 
	# top_buttons.each { |v| v.show_all }
#else
	# layers["license"].show_all 
#end		
layers.each { |k,v| v.hide_all }
top_buttons.each { |v| v.show_all }
layers["start"].show_all 

Gtk.main